﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Runtime.CompilerServices;
using System.Text;
using System.Threading.Tasks;
using Write_erase;
using Write_erase.Classes;

namespace Write_erase
{
    public partial class Product
    {
        public string ColorBG
        {
            get
            {
                if(ProductDiscountAmount/100 > 0.15)
                {
                    return "#7fff00";
                }
                else
                {
                    return "#ffffff";
                }
            }
        }
        public string Sup
        {
            get
            {
                string sp = "";
                List<ProductSupplier> suppliers = DataBaseClass.entity.ProductSupplier.ToList();
                foreach(ProductSupplier supplier in suppliers)
                {
                    sp = supplier.Name;
                }
                return "Производитель: " + sp;
            }
        }
        public string CostD
        {
            get
            {
                if (ProductDiscountAmount / 100 == 0)
                    return ProductCost.ToString();
                else
                {
                    double sum = (double)(ProductCost - ProductCost * Convert.ToDecimal(ProductDiscountAmount / 100));
                    return sum.ToString();
                }
            }
        }
        public string Price
        {
            get
            {
                if(ProductDiscountAmount/100 == 0)
                return "Цена: " + ProductCost.ToString();
                else
                {
                    double sum = (double)(ProductCost - ProductCost * Convert.ToDecimal(ProductDiscountAmount / 100));
                    return "Цена: " + sum.ToString();
                }
            }
        }
        private int count = 0;
        public int CountProduct { get => count; set { count = value; OnPropertyChanged(); } }
        public event PropertyChangedEventHandler PropertyChanged;
        public void OnPropertyChanged([CallerMemberName] string prop = "")
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(prop));
        }
        public string Discount
        {
            get
            {
                return "Скидка: " + Convert.ToString(ProductDiscountAmount) + " %";
            }
        }
        public string Photo
        {
            get
            {
                if(ProductPhoto != "")
                {
                    return "/Images/" + ProductPhoto.ToString();
                }
                else
                {
                    return "/Images/picture.png";
                }
            }
        }
    }
}
